import '../../../infrastructure/controller.dart';
import '../../../infrastructure/loadable_state.dart';
import 'marianum_message_state.dart';

class MarianumMessageController extends Controller<LoadableState<MarianumMessageState>> {
  MarianumMessageController() : super(const LoadableState(loadingState: LoadingState.none, data: MarianumMessageState(test: [])));

  void loading() {
    emit(state.loading());
    Future.delayed(const Duration(seconds: 3)).then((value) => emit(state.done(const MarianumMessageState(test: []))));
  }
  
  void backgroundLoading() {
    emit(state.cached(const MarianumMessageState(test: [])));
  }

  void done() {
    emit(state.done(const MarianumMessageState(test: [])));
  }

  void error() {
    emit(state.error(state: const MarianumMessageState(test: [])));
  }
}
