import 'dart:async';

import 'package:connectivity_plus/connectivity_plus.dart';

import '../../../../infrastructure/controller.dart';
import 'error_bar_state.dart';

class ErrorBarController extends Controller<ErrorBarState> {
  late StreamSubscription<List<ConnectivityResult>> _updateStream;

  ErrorBarController() : super(const ErrorBarState(connections: null)) {
    emitState(List<ConnectivityResult> v) => emit(state.copyWith(connections: v));
    
    Connectivity().checkConnectivity().then(emitState);
    _updateStream = Connectivity().onConnectivityChanged.listen(emitState);
  }

  bool connectivityStatusKnown() => state.connections != null;
  bool isConnected({bool? def}) => !(state.connections?.contains(ConnectivityResult.none) ?? def!);

  @override
  Future<void> close() {
    _updateStream.cancel();
    return super.close();
  }
}
