import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';

import '../infrastructure/controller.dart';

class ControllerConsumer<TController extends Controller<TState>, TState> extends StatelessWidget {
  final Widget Function(BuildContext context, TState state) child;
  const ControllerConsumer({required this.child, super.key});

  @override
  Widget build(BuildContext context) => BlocBuilder<TController, TState>(builder: child);
}
